/*********************************************************************
* This software module was originally developed by contributors 
* in the course of development of the ISO/IEC 23002-1 "accuracy requirements 
* for implementations of integer-output 8x8 IDCT" standard for reference 
* purposes and its performance may not have been optimized. This software 
* module is an implementation of one or two more tools as specified by the 
* ISO/IEC 23002-1 standard.
*
* ISO/IEC gives You a royalty-free, worldwide, non-exclusive, copyright 
* license to copy, distribute, and make derivative works of this software 
* module or modifications thereof for use in implementations of the 
* ISO/IEC 23002-1 standard in products that satisfy conformance criteria 
* (if any).
*
* Those intending to use this software module in products are advised that 
* its use may infringe existing patents. ISO/IEC have no liability for use 
* of this software module or modifications thereof.
*
* Copyright is not released for products that do not conform to audiovisual 
* and image-coding related ITU Recommendations and/or ISO/IEC International 
* Standards.
*
******** Begin section to be removed when relevant standard is published *****
*
* Assurance that the originally developed software module can be used
* (1) in the ISO/IEC 23002-1 standard once the ISO/IEC 23002-1
*     standard has been adopted; and
* (2) to develop the ISO/IEC 23002-1 standard:
*
* The contributors each individually grant ISO/IEC 
* all rights necessary to include the originally developed software module or 
* modifications thereof in the ISO/IEC 23002-1 standard and to permit 
* ISO/IEC to offer You a royalty-free, worldwide, non-exclusive, copyright 
* license to copy, distribute, and make derivative works for use in 
* implementations of the ISO/IEC 23002-1 standard in products that satisfy 
* conformance criteria (if any), and to the extent that such originally 
* developed software module or portions of it are included in the ISO/IEC 
* 23002-1 standard. To the extent that the contributors
* own patent rights that would be required to make, use, or sell the originally 
* developed software module or portions thereof included in the ISO/IEC 
* 23002-1 standard in a conforming product, the contributors each
* individually will assure the ISO/IEC that they are willing to 
* negotiate licenses under reasonable and non-discriminatory terms and 
* conditions with applicants throughout the world.
*
* ISO/IEC gives You a free license to this software module or modifications
* thereof for the sole  purpose of developing the ISO/IEC 23002-1 standard.
*
******** end of section to be removed when the standard is published *****
*
* The contributors retain full rights to modify and 
* use the code for their own purposes, assign or donate the code to a third 
* party and to inhibit third parties from using the code for products that do 
* not conform to MPEG-related ITU Recommendations and/or ISO/IEC International 
* Standards.
*
* This copyright notice must be included in all copies or derivative works.
* Copyright (c) ISO/IEC 2006.
**********************************************************************/

extern void ref_idct (short *block);

/* simple random noise generator: */
int irbit2() {
  static unsigned int iseed = 0xAAAAAAAA;
  return (iseed & 0x20000)? (iseed = ((iseed ^ 0x13) << 1) | 1, 1):  (iseed <<= 1, 0);
}

/*
 * Example 8x8 IDCT:
 */
void example_idct (short *block)
{
    /* an example (not precise) IDCT implementation: */
    block [63] ^= irbit2();   // add noise
    ref_idct (block);         // run reference IDCT
}

